/*
*
*
* Cierna obrazovka na zaciatku je sposobena BLUR filtrom, je potrebne chvilu cakat
*
* Stlacenim klavesy enter sa vygeneruje nova scena
*
* Medzernik uklada screenshot
*
*
*/


int starcount=int(random(7000,10000));
float planetnum=random(1,7);
int planetcount=floor(planetnum);
float baseTilt=random(0,TWO_PI);
Star[] stars=new Star[starcount];
ArrayList<Planet> planets=new ArrayList<Planet>();
float sunHue=40+random(-20,20);
float sunSize=random(120,250);
int start=1;
float multiplier=1.0;

//float orbitDuration = 250;
//float orbitRad = 50;

void setup(){
  println(planetcount);
  colorMode(HSB,360,100,100);
  frameRate(60);
  //size(1500,1000);
  fullScreen();
  background(0);
  for(int i=0;i<starcount;i++){
    stars[i]=new Star(random(0,width),random(0,height),random(0,2),random(0,100));
  }
 for(int n=0;n<planetcount;n++){
    planets.add(new Planet(random(300,width/2),random(300,width/2),random(-PI/10,PI/10),random(0,200),150.0*2,random(50,110),random(0,360),random(0,80),random(50,100)));
    planets.get(n).offset=max(planets.get(n).xrad,planets.get(n).yrad)-sunSize*1.5;
    planets.get(n).time=random(planets.get(n).xrad+planets.get(n).yrad/4*0.3,planets.get(n).xrad+planets.get(n).yrad/4*1.5);
  } 
  noStroke();
  smooth(4);
}



void draw(){  
  
  //println(planetcount);
  //println(starcount);
  
  noStroke();
  fill(0,0,100);
  
  if(!(frameCount<start+10)){
    for(int i=0; i<starcount;i++)
    {
      if(stars[i]==null){
        stars[i]=new Star(random(0,width),random(0,height),random(0,2),random(0,100));
      }
      if(!stars[i].life()){
        stars[i]=new Star(random(0,width),random(0,height),random(0,2),100);
      }    
      stars[i].disp();
    }
    
    multiplier=1.0;
    for(int n=0; n<planets.size() ;n++)
    {
      planets.get(n).disp();
      //println(planets[n].hue,planets[n].sat,planets[n].val);
      multiplier+=0.15;
    }
    
  }  
  
  noStroke();
  if(frameCount<start+10)filter(BLUR,2);
  fill(sunHue-20,100-map(sunHue,20,60,0,90),100);
  ellipse(width/2,height/2,sunSize,sunSize);
  if(frameCount==start)filter(BLUR,15);
  fill(sunHue,100-map(sunHue,20,60,0,90),100);
  ellipse(width/2,height/2,sunSize,sunSize);
  
  //saveFrame();
  
}
  
  
  
void keyPressed() {
  
  if(key==ENTER){
  
  planets.clear();
  
  float planetnum=random(1,7);
  int planetcount=floor(planetnum);
  
  println(planetcount);
  
  baseTilt=random(0,TWO_PI);
  sunHue=40+random(-20,20);
  sunSize=random(120,250);
  background(0);
  start=frameCount+1;
  for(int i=0; i<starcount;i++)
  {
  stars[i]=null;
  }
  for(int n=0;n<planetcount;n++)
  {
     planets.add(new Planet(random(300,width/2),random(300,width/2),random(-PI/10,PI/10),random(0,200),150.0*2,random(50,110),random(0,360),random(0,80),random(50,100)));
    planets.get(n).offset=max(planets.get(n).xrad,planets.get(n).yrad)-sunSize*1.5;
    planets.get(n).time=random(planets.get(n).xrad+planets.get(n).yrad/4*0.3,planets.get(n).xrad+planets.get(n).yrad/4*1.5);
    //println(planets[i].time);
  }  
  }
  if(key==' '){
    saveFrame("screenshot####.png");
  }
}



class Star { 
  float x, y, size, bright; 
  Star (float xpos, float ypos, float s, float b) {  
    x=xpos;
    y=ypos;
    size=s;
    bright=b;
  } 
  void disp() {
    if(!overCircle(x, y, sunSize*0.75)){
    fill(0);
    ellipse(x,y,size*2,size*2);
    fill(255,bright);
    ellipse(x,y,size,size);
    bright=bright-0.5;
    }
  }
  boolean life(){
    return(bright>0);
  }
} 

class Planet { 
  float xrad, yrad, angle, offset, time, size, hue, sat, val; 
  Planet (float xpos, float ypos, float a, float o, float t, float s, float hu, float sa, float va) {  
    xrad=xpos;
    yrad=ypos;
    angle=a;
    offset=o;
    time=t;    
    size=s;
    hue=hu;
    sat=sa;
    val=va;
  } 
  
  void disp(){
    float ang=TWO_PI*frameCount/time;
    float x = cos(ang)*xrad;
    float y = sin(ang)*yrad;
    
    noFill();
    stroke(255);
    strokeWeight(1.5);
    pushMatrix();    
    translate(cos(baseTilt+angle)*offset,sin(baseTilt+angle)*offset);
    translate(width/2,height/2);
    if(xrad>yrad)
    rotate(baseTilt+angle);
    if(yrad>xrad)    
    rotate(baseTilt+angle+PI/2);
    scale(multiplier);
    translate(-width/2,-height/2);
    ellipse(width/2,height/2,xrad*2,yrad*2);
    stroke(0);
    strokeWeight(20);
    fill(hue,sat,val);
    ellipse(x+width/2,y+height/2,size,size);   
    popMatrix();
  }  
} 

boolean overCircle(float x, float y, float diameter) {
    if (sqrt(sq(x-width/2) + sq(y-height/2)) < diameter ) {
      return true;
    } else {
      return false;
    }
}